

  Structure MyD3DTLVERTEX
    x.f
    y.f
    z.f
    rhw.f
    Color.l
    tu.f
    tv.f
  EndStructure 
  
  Structure PB_DX9Sprite3D
    TexRes.l                    ; TexRes
    Vertice.MyD3DTLVERTEX[4]    ; The 4 vertices for the rectangle sprite
    TmpVertice.MyD3DTLVERTEX[4] ; The 4 vertices for the rectangle sprite
    Width.l			                ; width set with ZoomSprite3D()
    Height.l			              ; height set with ZoomSprite3D()
    RealWidth.l
    RealHeight.l
    Angle.f
    Transformed.l
  EndStructure


  Procedure DX9S_Sprite3DColor(Sprite3D.l,Color1.l,Color2.l,Color3.l,Color4.l)
    *ptr.PB_DX9Sprite3D=IsSprite3D(Sprite3D)
    If *ptr=0:ProcedureReturn #False:EndIf
    
    *ptr\Vertice[0]\Color=Color1
    *ptr\Vertice[1]\Color=Color2
    *ptr\Vertice[2]\Color=Color3
    *ptr\Vertice[3]\Color=Color4
    
    ProcedureReturn #True
  EndProcedure



InitSprite()
InitSprite3D()
InitKeyboard()

OpenWindow(1,0,0,640,480,"DX9Subsystem test",#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_Minimize|#PB_Window_SizeGadget)
OpenWindowedScreen(WindowID(1),10,10,800,600,1,10,10)

CreateSprite(1,128,128,#PB_Sprite_Texture)

StartDrawing(SpriteOutput(1))
For C=0 To 10000
Box(Random(128),Random(128),10,10,Random($FFFFFF))
Next
StopDrawing()

CreateSprite3D(1,1)

Repeat


ExamineKeyboard()

ClearScreen(#Blue)

Start3D()

;change the color of the 3d sprite
;note: the colors DX9S_Sprite3DColor() for are in BGR format not in RGB format, so you have to use RGB() this way
; RGB(Blue,Green,Red) to reach the wanted result ;)

DX9S_Sprite3DColor(1,$FF0000,$FF,$FF00,$FFFFFF)

RotateSprite3D(1,1,1)

DisplaySprite3D(1,30,30)

Stop3D()

FlipBuffers()

Until WindowEvent()=#PB_Event_CloseWindow

; IDE Options = PureBasic v4.01 (Windows - x86)
; CursorPosition = 41
; FirstLine = 32
; Folding = -
; Executable = Test3_DX9.exe
; SubSystem = DX9